## adequate 0.15.1

=== tests/Makefile ===
arch = $(shell dpkg-architecture -qDEB_HOST_ARCH)
changes = adequate-testpkg_1_$(arch).changes

.PHONY: all
all: $(changes)
	$(info Run "make run" as root.)
	$(info Alternatively, if you have user-mode-linux installed, you can try "make run-uml" as normal user.)
	$(info )@:

$(changes):
	cd testpkg && dpkg-buildpackage -b -us -uc

.PHONY: run
run: $(changes)
	./run-tests $(<)

.PHONY: run-uml
run-uml: $(changes)
	fallocate -l 1G uml-guest-swap
	linux init=$(CURDIR)/uml-guest-init \
		$(shell printf '%s' '$(CURDIR)' | base64 -w0 | tr = _) \
		$(shell printf '%s' '$(<)' | base64 -w0 | tr = _) \
		rootfstype=hostfs ubd0=uml-guest-swap mem=128M quiet con=null,fd:1 \
	| cat

.PHONY: clean
clean:
	cd testpkg && debian/rules clean
	rm -f *.changes *.deb
	rm -f uml-guest-swap

# vim:ts=4 sts=4 sw=4 noet

=== tests/testpkg/debian/changelog ===
adequate-testpkg (1) unstable; urgency=low

  * Initial release.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 02 Feb 2013 13:08:18 +0100

=== debian/control ===
Source: adequate
Section: utils
Priority: optional
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 7), dh-buildinfo,
 perl (>= 5.14),
 python3 (>= 3.2), python3-apt
Standards-Version: 3.9.6
Vcs-Hg: https://bitbucket.org/jwilk/adequate
Vcs-Browser: https://bitbucket.org/jwilk/adequate
Homepage: http://jwilk.net/software/adequate

Package: adequate
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, perl (>= 5.14), debconf
Recommends: pkg-config (>= 0.27)
Description: Debian package quality testing tool
 adequate checks packages installed on the system and reports bugs and policy
 violations.
 .
 The following checks are currently implemented:
  * broken symlinks;
  * missing copyright file;
  * obsolete conffiles;
  * Python modules not byte-compiled;
  * /bin and /sbin binaries requiring /usr/lib libraries;
  * missing libraries, undefined symbols, symbol size mismatches;
  * license conflicts;
  * program name collisions;
  * missing alternatives;
  * missing binfmt interpreters and detectors;
  * missing pkg-config dependencies.

=== tests/testpkg/debian/rules ===
#!/usr/bin/make -f

tmp = debian/tmp
at = adequate-test

.PHONY: clean
clean:
	dh_clean

.PHONY: build
build: build-stamp

build-stamp:
	mkdir -p $(tmp)
	# bin-or-sbin-binary-requires-usr-lib-library; library-not-found
	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-lib.so.0 -o $(tmp)/libadequate-lib.so.0
	ln -sf libadequate-lib.so.0 $(tmp)/libadequate-lib.so
	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-usrlib.so.0 -o $(tmp)/libadequate-usrlib.so.0
	ln -sf libadequate-usrlib.so.0 $(tmp)/libadequate-usrlib.so
	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -ladequate-lib -o $(tmp)/adequate-lib1
	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-lib1 adequate-lib{}
	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -ladequate-usrlib -o $(tmp)/adequate-usrlib1
	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-usrlib1 adequate-usrlib{}
	# incompatible-licenses
	$(CC) lib.c -fPIC -shared -Wl,-soname,libssl.so.1.0.0 -o $(tmp)/libssl.so
	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.6 -o $(tmp)/libreadline.so
	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lssl -lreadline -o $(tmp)/adequate-license-conflict
	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lreadline -o $(tmp)/adequate-license-conflict-dep5
	# missing-version-information
	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versionless.so.0
	ln -sf lib$(at)-versionless.so.0 $(tmp)/lib$(at)-versionless.so
	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-msvi -l$(at)-versionless
	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 lib.c -o $(tmp)/lib$(at)-versionless.so.0
	# symbol-size-mismatch
	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 lib.c -o $(tmp)/lib$(at)-symsize.so.0
	ln -sf lib$(at)-symsize.so.0 $(tmp)/lib$(at)-symsize.so
	$(CC) symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 -DADEQUATE_SYMBOL_SIZE=42 lib.c -o $(tmp)/lib$(at)-symsize.so.0
	# undefined-symbol
	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us1
	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
	# py-file-not-bytecompiled; pyshared-file-not-bytecompiled
	cp *.py debian/tmp/
	python2.7 -m compileall debian/tmp/
	touch $(@)

.PHONY: build-arch build-indep
build-arch build-indep:
	$(error $(@) is not implemented)

.PHONY: binary
binary:
	dh_install
	dh_installdocs -N adequate-testpkg-missing-copyright-file
	dh_installchangelogs
	dh_link
	dh_compress
	dh_fixperms
	dh_strip
	dh_makeshlibs
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb
	rm debian/adequate-testpkg-obsolete-conffile/etc/adequate/test-obsolete-conffile
	sed -i -e '/test-obsolete/d' debian/adequate-testpkg-obsolete-conffile/DEBIAN/conffiles
	cp -f debian/files debian/files.orig
	dh_gencontrol -p adequate-testpkg-obsolete-conffile -- -v2 -fdebian/files2
	cat debian/files2 >> debian/files
	rm -f debian/files2
	dh_md5sums -p adequate-testpkg-obsolete-conffile
	dh_builddeb -p adequate-testpkg-obsolete-conffile

.PHONY: binary-arch binary-indep
binary-arch binary-indep:
	$(error $(@) is not implemented)

# vim:ts=4 sts=4 sw=4 noet

=== tests/testpkg/debian/control ===
Source: adequate-testpkg
Section: misc
Priority: extra
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 7), python2.7
Standards-Version: 3.9.4

Package: adequate-testpkg-bin-or-sbin-binary-requires-usr-lib-library
Architecture: any
Description: adequate test package; do not install
  bin-or-sbin-binary-requires-usr-lib-library /bin/adequate-usrlib1 => /usr/lib/libadequate-usrlib.so.0
  bin-or-sbin-binary-requires-usr-lib-library /sbin/adequate-usrlib2 => /usr/lib/libadequate-usrlib.so.0

Package: adequate-testpkg-broken-symlink
Architecture: all
Description: adequate test package; do not install
  broken-symlink /usr/share/adequate/test-broken-symlink -> /this/file/does/not/exist

Package: adequate-testpkg-library-not-found
Architecture: any
Description: adequate test package; do not install
  library-not-found /bin/adequate-lib1 => libadequate-lib.so.0

Package: adequate-testpkg-incompatible-licenses
Architecture: any
Description: adequate test package; do not install
  incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.6)

Package: adequate-testpkg-incompatible-licenses-dep5
Architecture: any
Description: adequate test package; do not install
  incompatible-licenses /usr/bin/adequate-license-conflict-dep5 GPLv2 + GPLv3+ (libreadline.so.6)

Package: adequate-testpkg-missing-alternative
Architecture: all
Provides: x-terminal-emulator, x-window-manager
Description: adequate test package; do not install
  missing-alternative x-terminal-emulator
  missing-alternative x-window-manager

Package: adequate-testpkg-missing-copyright-file
Architecture: all
Description: adequate test package; do not install
  missing-copyright-file /usr/share/doc/adequate-testpkg-missing-copyright-file/copyright

Package: adequate-testpkg-missing-pkgconfig-dependency
Architecture: all
Depends: pkg-config (>= 0.27)
Description: adequate test package; do not install
  missing-pkgconfig-dependency libadequate => libnonexistent

Package: adequate-testpkg-missing-symbol-version-information
Architecture: any
Description: adequate test package; do not install
  missing-symbol-version-information /usr/bin/adequate-test-msvi => /usr/lib/libadequate-test-versionless.so.0

Package: adequate-testpkg-obsolete-conffile
Architecture: all
Description: adequate test package; do not install
  obsolete-conffile /etc/adequate/test-obsolete-conffile

Package: adequate-testpkg-program-name-collision
Architecture: all
Description: adequate test package; do not install
  program-name-collision /usr/games/true (bash builtin command)
  program-name-collision /usr/games/true /bin/true

Package: adequate-testpkg-py-file-not-bytecompiled
Architecture: all
Depends: python (>= 2.7), python (<< 2.8)
Description: adequate test package; do not install
  py-file-not-bytecompiled /usr/lib/python2.7/dist-packages/adequate/test_no_pyc.py

Package: adequate-testpkg-pyshared-file-not-bytecompiled
Architecture: all
Depends: python

## adequate 0.15.1ubuntu1

=== debian/changelog ===
adequate (0.15.1ubuntu1) yakkety; urgency=medium

  * Compile symbol-size-mismatch test package with -fno-PIE to trigger
    symbol size missmatch warning. LP: #1619377

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 01 Sep 2016 17:41:27 +0100

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -34,7 +34,7 @@
 	# symbol-size-mismatch
 	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 lib.c -o $(tmp)/lib$(at)-symsize.so.0
 	ln -sf lib$(at)-symsize.so.0 $(tmp)/lib$(at)-symsize.so
-	$(CC) symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
+	$(CC) -fno-PIE -no-pie symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
 	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 -DADEQUATE_SYMBOL_SIZE=42 lib.c -o $(tmp)/lib$(at)-symsize.so.0
 	# undefined-symbol
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0

## adequate 0.15.1ubuntu2

=== debian/changelog ===
adequate (0.15.1ubuntu2) zesty; urgency=medium

  * Add libreadline7

 -- Iain Lane <iain@orangesquash.org.uk>  Mon, 31 Oct 2016 17:45:07 +0000

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-usrlib1 adequate-usrlib{}
 	# incompatible-licenses
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libssl.so.1.0.0 -o $(tmp)/libssl.so
-	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.6 -o $(tmp)/libreadline.so
+	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.7 -o $(tmp)/libreadline.so
 	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lssl -lreadline -o $(tmp)/adequate-license-conflict
 	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lreadline -o $(tmp)/adequate-license-conflict-dep5
 	# missing-version-information

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -24,12 +24,12 @@
 Package: adequate-testpkg-incompatible-licenses
 Architecture: any
 Description: adequate test package; do not install
-  incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.6)
+  incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.7)
 
 Package: adequate-testpkg-incompatible-licenses-dep5
 Architecture: any
 Description: adequate test package; do not install
-  incompatible-licenses /usr/bin/adequate-license-conflict-dep5 GPLv2 + GPLv3+ (libreadline.so.6)
+  incompatible-licenses /usr/bin/adequate-license-conflict-dep5 GPLv2 + GPLv3+ (libreadline.so.7)
 
 Package: adequate-testpkg-missing-alternative
 Architecture: all

## adequate 0.15.1ubuntu4

=== debian/changelog ===
adequate (0.15.1ubuntu4) artful; urgency=medium

  * Don't run the test for an undefined symbol in an executable. Always
    failed on ppc64el, and now fails on amd64 and i386 as well with
    updated binutils. See PR ld/22126.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 12 Sep 2017 18:50:31 +0200

adequate (0.15.1ubuntu3) artful; urgency=medium

  * debian/tests/run-test: Skip over non-deb members in changes files.

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 22 Apr 2017 00:51:26 -0600

## adequate 0.15.1ubuntu5

=== debian/changelog ===
adequate (0.15.1ubuntu5) bionic; urgency=medium

  * Fix regular expression for undefined symbol output from ldd
    (lost a comma).

 -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 28 Mar 2018 10:49:37 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: adequate
 Section: utils
 Priority: optional
-Maintainer: Jakub Wilk <jwilk@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jakub Wilk <jwilk@debian.org>
 Build-Depends: debhelper (>= 7), dh-buildinfo,
  perl (>= 5.14),
  python3 (>= 3.2), python3-apt

=== debian/rules ===
#!/usr/bin/make -f

version = $(word 2,$(shell dpkg-parsechangelog | grep ^Version:))

.PHONY: clean
clean: doc/Makefile tests/Makefile
	$(MAKE) -C doc/ clean
	$(MAKE) -C tests/ clean
	dh_clean debian/build-stamp

.PHONY: build build-arch build-indep
build: build-indep
build-indep: debian/build-stamp

debian/build-stamp: doc/Makefile adequate
	$(MAKE) -B -C doc/
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	adt_adequate=./adequate adt_testpkg=coreutils debian/tests/smoke-test
endif
	touch $(@)

.PHONY: binary binary-arch binary-indep

binary: binary-indep
binary-indep: build-indep
	dh_testroot
	dh_prep
	dh_installdirs
	dh_install
	sed -i \
		-r -e 's/^(our \$$VERSION) =.*/\1 = "$(version)";/' \
		debian/*/usr/bin/*
	dh_installman doc/*.1
	dh_perl
	dh_installdocs
	dh_installchangelogs
	dh_buildinfo
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# vim:ts=4 sts=4 sw=4 noet

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -39,7 +39,11 @@
 	# undefined-symbol
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
+# what is the purpose of this test? always failed on ppc64el, starts
+# failing on x86 architectures with binutils-2.29
+ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386 x32 ppc64el))
 	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us1
+endif
 	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	# py-file-not-bytecompiled; pyshared-file-not-bytecompiled

=== debian/tests/control ===
Tests: smoke-test
Depends: adequate

Tests: full-test
Depends: adequate,
 build-essential, debhelper,
 python3 (>= 3.2), python3-apt,
 python (>= 2.7), python (<< 2.8),
 pkg-config (>= 0.27)
Restrictions: breaks-testbed needs-root

## adequate 0.15.2

=== debian/changelog ===
adequate (0.15.2) unstable; urgency=medium

  * QA upload, see #786808.

  [ Jakub Wilk ]
  * Update copyright years.
  * Add license information for libpoppler.so.60 and libpoppler.so.61.

  [ Axel Beckert ]
  * Set Maintainer to Debian QA Group.
  * Convert packaging VCS repo to git and use salsa.debian.org for it.
  * Use HTTPS for debian/copyright format URL.
  * Use dpkg instead of coreutils for build-time smoke test. (Closes:
    #922773)
  * Apply "wrap-and-sort -a".
  * Use debhelper compatibility level 12.
    + Drop debian/compat.
    + Depend on "debhelper-compat (= 12)".
  * Drop version from (build-)dependency on perl.  (5.14 is already in
    oldoldstable.) Use only ${perl:Depends} in binary package.
  * Use $(DEB_VERSION) instead of dpkg-parsechangelog.
  * Declare compliance with Debian Policy 4.3.0. (No changes needed.)
  * Set "Rules-Requires-Root: no".
  * Drop "compression = gzip" from debian/source/options.
  * Fix tests/run-tests to not trip over .build files in .changes files.

 -- Axel Beckert <abe@debian.org>  Fri, 01 Mar 2019 02:12:21 +0100

=== debian/control ===
Source: adequate
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 12),
               dh-buildinfo,
               perl,
               python3 (>= 3.2),
               python3-apt
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/debian/adequate.git
Vcs-Browser: https://salsa.debian.org/debian/adequate
Homepage: https://salsa.debian.org/debian/adequate
Rules-Requires-Root: no

Package: adequate
Architecture: all
Depends: debconf,
         ${misc:Depends},
         ${perl:Depends}
Recommends: pkg-config (>= 0.27)
Description: Debian package quality testing tool
 adequate checks packages installed on the system and reports bugs and policy
 violations.
 .
 The following checks are currently implemented:
  * broken symlinks;
  * missing copyright file;
  * obsolete conffiles;
  * Python modules not byte-compiled;
  * /bin and /sbin binaries requiring /usr/lib libraries;
  * missing libraries, undefined symbols, symbol size mismatches;
  * license conflicts;
  * program name collisions;
  * missing alternatives;
  * missing binfmt interpreters and detectors;
  * missing pkg-config dependencies.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-version = $(word 2,$(shell dpkg-parsechangelog | grep ^Version:))
+include /usr/share/dpkg/pkg-info.mk
 
 .PHONY: clean
 clean: doc/Makefile tests/Makefile
@@ -15,7 +15,7 @@
 debian/build-stamp: doc/Makefile adequate
 	$(MAKE) -B -C doc/
 ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
-	adt_adequate=./adequate adt_testpkg=coreutils debian/tests/smoke-test
+	adt_adequate=./adequate adt_testpkg=dpkg debian/tests/smoke-test
 endif
 	touch $(@)
 
@@ -28,7 +28,7 @@
 	dh_installdirs
 	dh_install
 	sed -i \
-		-r -e 's/^(our \$$VERSION) =.*/\1 = "$(version)";/' \
+		-r -e 's/^(our \$$VERSION) =.*/\1 = "$(DEB_VERSION)";/' \
 		debian/*/usr/bin/*
 	dh_installman doc/*.1
 	dh_perl

=== debian/tests/control ===
Tests: smoke-test
Depends: adequate

Tests: full-test
Depends: adequate,
         build-essential,
         debhelper,
         pkg-config (>= 0.27),
         python (<< 2.8),
         python (>= 2.7),
         python3 (>= 3.2),
         python3-apt
Restrictions: breaks-testbed needs-root

## adequate 0.15.3

=== debian/changelog ===
adequate (0.15.3) unstable; urgency=medium

  * QA upload.
  * Don't use python2 in the autopkg tests.

 -- Matthias Klose <doko@debian.org>  Thu, 08 Oct 2020 12:46:44 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 12),
                dh-buildinfo,
                perl,
-               python3 (>= 3.2),
+               python3,
                python3-apt
 Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/debian/adequate.git

=== debian/tests/control ===
Tests: smoke-test
Depends: adequate

Tests: full-test
Depends: adequate,
         build-essential,
         debhelper,
         pkg-config (>= 0.27),
         python3,
         python3-apt
Restrictions: breaks-testbed needs-root

## adequate 0.15.4

=== tests/Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 .PHONY: clean
 clean:
 	cd testpkg && debian/rules clean
-	rm -f *.changes *.deb
+	rm -f *.changes *.buildinfo *.deb
 	rm -f uml-guest-swap
 
 # vim:ts=4 sts=4 sw=4 noet

=== debian/changelog ===
adequate (0.15.4) unstable; urgency=medium

  * QA upload.

  [ Axel Beckert ]
  * Retroactively mention #860941 in the previous changelog entry.

  [ Debian Janitor ]
  * Update standards version to 4.5.0, no changes needed.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

  [ Stuart Prescott ]
  * Drop Python 2 dependencies (Closes: #942926)
    - Port tests to use Python 3 paths
    - Drop Python 2-specific pyshared test
  * Don't build dbgsym packages in test suite.
  * Clean .buildinfo file from test suite.
  * Add dummy libraries to the test suite packages so that they can be found
    by ldd when running the tests.

 -- Axel Beckert <abe@debian.org>  Wed, 03 Feb 2021 04:07:01 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                perl,
                python3,
                python3-apt
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian/adequate.git
 Vcs-Browser: https://salsa.debian.org/debian/adequate
 Homepage: https://salsa.debian.org/debian/adequate

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-usrlib1 adequate-usrlib{}
 	# incompatible-licenses
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libssl.so.1.0.0 -o $(tmp)/libssl.so
-	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.7 -o $(tmp)/libreadline.so
+	$(CC) lib.c -fPIC -shared -Wl,-soname,libreadline.so.6 -o $(tmp)/libreadline.so
 	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lssl -lreadline -o $(tmp)/adequate-license-conflict
 	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -lreadline -o $(tmp)/adequate-license-conflict-dep5
 	# missing-version-information
@@ -34,21 +34,17 @@
 	# symbol-size-mismatch
 	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 lib.c -o $(tmp)/lib$(at)-symsize.so.0
 	ln -sf lib$(at)-symsize.so.0 $(tmp)/lib$(at)-symsize.so
-	$(CC) -fno-PIE -no-pie symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
+	$(CC) symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
 	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 -DADEQUATE_SYMBOL_SIZE=42 lib.c -o $(tmp)/lib$(at)-symsize.so.0
 	# undefined-symbol
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
-# what is the purpose of this test? always failed on ppc64el, starts
-# failing on x86 architectures with binutils-2.29
-ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386 x32 ppc64el))
 	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us1
-endif
 	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	# py-file-not-bytecompiled; pyshared-file-not-bytecompiled
 	cp *.py debian/tmp/
-	python2.7 -m compileall debian/tmp/
+	python3 -m compileall debian/tmp/
 	touch $(@)
 
 .PHONY: build-arch build-indep
@@ -63,7 +59,7 @@
 	dh_link
 	dh_compress
 	dh_fixperms
-	dh_strip
+	dh_strip --no-automatic-dbgsym
 	dh_makeshlibs
 	dh_installdeb
 	dh_gencontrol

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: extra
 Maintainer: Jakub Wilk <jwilk@debian.org>
-Build-Depends: debhelper (>= 7), python2.7
+Build-Depends: debhelper (>= 7), python3
 Standards-Version: 3.9.4
 
 Package: adequate-testpkg-bin-or-sbin-binary-requires-usr-lib-library
@@ -24,12 +24,12 @@
 Package: adequate-testpkg-incompatible-licenses
 Architecture: any
 Description: adequate test package; do not install
-  incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.7)
+  incompatible-licenses /usr/bin/adequate-license-conflict OpenSSL (libssl.so.1.0.0) + GPLv3+ (libreadline.so.6)
 
 Package: adequate-testpkg-incompatible-licenses-dep5
 Architecture: any
 Description: adequate test package; do not install
-  incompatible-licenses /usr/bin/adequate-license-conflict-dep5 GPLv2 + GPLv3+ (libreadline.so.7)
+  incompatible-licenses /usr/bin/adequate-license-conflict-dep5 GPLv2 + GPLv3+ (libreadline.so.6)
 
 Package: adequate-testpkg-missing-alternative
 Architecture: all
@@ -67,10 +67,8 @@
 
 Package: adequate-testpkg-py-file-not-bytecompiled
 Architecture: all
-Depends: python (>= 2.7), python (<< 2.8)
+Depends: python3
 Description: adequate test package; do not install
-  py-file-not-bytecompiled /usr/lib/python2.7/dist-packages/adequate/test_no_pyc.py
+  py-file-not-bytecompiled /usr/lib/python3.1/dist-packages/adequate/test_no_pyc.py
+  py-file-not-bytecompiled /usr/lib/python3/dist-packages/adequate/test_no_pyc.py
 
-Package: adequate-testpkg-pyshared-file-not-bytecompiled
-Architecture: all
-Depends: python

## adequate 0.15.5

=== debian/changelog ===
adequate (0.15.5) unstable; urgency=medium

  * QA upload.
  * Try building the test packages at package build time.
  * The test for missing-symbol-version-information now also triggers a
    ldd-failure.
  * Fix building test binaries with unresolved symbols.
  * Disable emitting the bin-or-sbin-binary-requires-usr-lib-library tag.
  * Generate tests/testpkg/debian/control since adequate output slightly
    differs between non-merged-usr and merged-usr systems.  (Closes: #981899)
  * Switch to debhelper-compat (= 13) and use dh.
  * testpkg: Switch to debhelper-compat (= 13) and use dh.
  * Bump Standards-Version to 4.5.1, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 13 Feb 2021 11:31:40 +0100

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -3,14 +3,13 @@
 tmp = debian/tmp
 at = adequate-test
 
-.PHONY: clean
-clean:
-	dh_clean
+debian/control: debian/control.in
+	sed -r 's/#$(shell test "$$(readlink -f /bin)" = "$$(readlink -f /usr/bin)" || echo "non-")merged-usr#//' $< > $@
 
-.PHONY: build
-build: build-stamp
+%: debian/control
+	dh $@
 
-build-stamp:
+override_dh_auto_install:
 	mkdir -p $(tmp)
 	# bin-or-sbin-binary-requires-usr-lib-library; library-not-found
 	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-lib.so.0 -o $(tmp)/libadequate-lib.so.0
@@ -37,45 +36,35 @@
 	$(CC) symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
 	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 -DADEQUATE_SYMBOL_SIZE=42 lib.c -o $(tmp)/lib$(at)-symsize.so.0
 	# undefined-symbol
+	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 lib.c -o $(tmp)/lib$(at)-versioning.so.0
+	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
+	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us1 -l$(at)-versioning
+	nm $(tmp)/$(at)-us1 | grep 'U this_symbol_might_be_undefined'
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
-	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
-	$(CC) undef.c -fPIE -Wl,--unresolved-symbols,ignore-all -L$(tmp) -o $(tmp)/$(at)-us1
 	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
+	nm $(tmp)/$(at)-us2 | grep 'U this_symbol_might_be_undefined@ADEQUATE_TEST'
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	# py-file-not-bytecompiled; pyshared-file-not-bytecompiled
 	cp *.py debian/tmp/
 	python3 -m compileall debian/tmp/
-	touch $(@)
 
-.PHONY: build-arch build-indep
-build-arch build-indep:
-	$(error $(@) is not implemented)
+override_dh_installdocs:
+	dh_installdocs -N adequate-testpkg-missing-copyright-file
 
-.PHONY: binary
-binary:
-	dh_install
-	dh_installdocs -N adequate-testpkg-missing-copyright-file
-	dh_installchangelogs
-	dh_link
-	dh_compress
-	dh_fixperms
+override_dh_missing:
+	dh_missing --list-missing
+
+override_dh_strip:
 	dh_strip --no-automatic-dbgsym
-	dh_makeshlibs
-	dh_installdeb
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
+
+# we build binaries with missing symbols
+override_dh_shlibdeps:
+
+execute_after_dh_builddeb:
 	rm debian/adequate-testpkg-obsolete-conffile/etc/adequate/test-obsolete-conffile
 	sed -i -e '/test-obsolete/d' debian/adequate-testpkg-obsolete-conffile/DEBIAN/conffiles
-	cp -f debian/files debian/files.orig
 	dh_gencontrol -p adequate-testpkg-obsolete-conffile -- -v2 -fdebian/files2
 	cat debian/files2 >> debian/files
 	rm -f debian/files2
 	dh_md5sums -p adequate-testpkg-obsolete-conffile
 	dh_builddeb -p adequate-testpkg-obsolete-conffile
-
-.PHONY: binary-arch binary-indep
-binary-arch binary-indep:
-	$(error $(@) is not implemented)
-
-# vim:ts=4 sts=4 sw=4 noet

## adequate 0.15.6

=== doc/Makefile ===
version = $(word 2,$(shell cd .. && dpkg-parsechangelog | grep ^Version:))

.PHONY: all
all: adequate.1

tags.desc: ../adequate
	../private/update-tags

adequate.pod: adequate.podt tags.desc ../adequate
	../private/generate-manpage > $(@).tmp
	mv $(@).tmp $(@)

%.1: %.pod
	date=$(shell sed -n -e "/^pod-date:/s///p" $(<)) && \
	pod2man --utf8 -c '' -d $$date -q none -r "$(*) $(version)" $(<) $(@)

.PHONY: clean
clean:
	rm -f adequate.pod *.1 *.tmp

# vim:ts=4 sts=4 sw=4 noet

=== debian/changelog ===
adequate (0.15.6) unstable; urgency=medium

  * QA upload.
  * Build libadequate-test-versionless.so.0 with -Wl,--no-as-needed.
    (Closes: #982443)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 26 Feb 2021 10:18:20 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Section: utils
 Priority: optional
 Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends: debhelper-compat (= 12),
-               dh-buildinfo,
+Build-Depends: debhelper-compat (= 13),
                perl,
                python3,
                python3-apt
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/debian/adequate.git
 Vcs-Browser: https://salsa.debian.org/debian/adequate
 Homepage: https://salsa.debian.org/debian/adequate
@@ -28,7 +27,6 @@
   * missing copyright file;
   * obsolete conffiles;
   * Python modules not byte-compiled;
-  * /bin and /sbin binaries requiring /usr/lib libraries;
   * missing libraries, undefined symbols, symbol size mismatches;
   * license conflicts;
   * program name collisions;

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versionless.so.0
 	ln -sf lib$(at)-versionless.so.0 $(tmp)/lib$(at)-versionless.so
 	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-msvi -l$(at)-versionless
-	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 lib.c -o $(tmp)/lib$(at)-versionless.so.0
+	$(CC) -shared -Wl,--no-as-needed -Wl,--soname=lib$(at)-versionless.so.0 lib.c -o $(tmp)/lib$(at)-versionless.so.0
 	# symbol-size-mismatch
 	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 lib.c -o $(tmp)/lib$(at)-symsize.so.0
 	ln -sf lib$(at)-symsize.so.0 $(tmp)/lib$(at)-symsize.so

=== debian/tests/control ===
Tests: smoke-test
Depends: adequate
Restrictions: superficial

Tests: full-test
Depends: adequate,
         build-essential,
         debhelper-compat (= 13),
         pkg-config (>= 0.27),
         python3,
         python3-apt
Restrictions: breaks-testbed needs-root

## adequate 0.15.7

=== debian/changelog ===
adequate (0.15.7) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + adequate: Drop versioned constraint on pkg-config in Recommends.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 25 May 2022 15:35:24 +0100

## adequate 0.15.8

=== debian/changelog ===
adequate (0.15.8) unstable; urgency=medium

  * QA upload.
  * Disable deprecation warnings about smartmatch, given, when in Perl
    5.38.
    This is only a band aid but it buys us time before the feature will be
    removed in perl 5.42 in roughly 2 years.
    Also fix version comparison for smartmatch being experimental warnings.
    (Closes: #1043228)

 -- gregor herrmann <gregoa@debian.org>  Tue, 08 Aug 2023 18:06:34 +0200

## adequate 0.15.9~deb12u1

=== debian/changelog ===
adequate (0.15.9~deb12u1) bookworm; urgency=medium

  * QA upload.
  * Rebuild for bookworm.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 03 Dec 2023 10:44:59 +0100

adequate (0.15.9) unstable; urgency=medium

  * QA upload.
  * Skip symbol-size-mismatch test on architectures where array symbols don't
    include a specific length.  (Closes: #1050066)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 23 Nov 2023 10:06:17 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 Depends: debconf,
          ${misc:Depends},
          ${perl:Depends}
-Recommends: pkg-config (>= 0.27)
+Recommends: pkg-config
 Description: Debian package quality testing tool
  adequate checks packages installed on the system and reports bugs and policy
  violations.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

override_dh_auto_clean:
	$(MAKE) -C doc/ clean
	$(MAKE) -C tests/ clean

override_dh_auto_build:
	$(MAKE) -B -C doc/

override_dh_auto_test:
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	adt_adequate=./adequate adt_testpkg=dpkg debian/tests/smoke-test
	$(MAKE) -C tests/ changes
endif

execute_after_dh_install:
	sed -i \
		-r -e 's/^(our \$$VERSION) =.*/\1 = "$(DEB_VERSION)";/' \
		debian/*/usr/bin/*

## adequate 0.15.9

=== tests/testpkg/debian/rules ===
--- 
+++ 
@@ -35,6 +35,8 @@
 	ln -sf lib$(at)-symsize.so.0 $(tmp)/lib$(at)-symsize.so
 	$(CC) symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
 	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 -DADEQUATE_SYMBOL_SIZE=42 lib.c -o $(tmp)/lib$(at)-symsize.so.0
+	readelf --wide --symbols $(tmp)/$(at)-symsize | grep this_symbol_size_varies
+	test "$$(readelf --wide --symbols $(tmp)/$(at)-symsize | grep this_symbol_size_varies | head -n 1 | awk '{print $$3}')" != "0" || touch $(tmp)/skip-symbol-size-mismatch
 	# undefined-symbol
 	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 lib.c -o $(tmp)/lib$(at)-versioning.so.0
 	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
@@ -60,6 +62,12 @@
 # we build binaries with missing symbols
 override_dh_shlibdeps:
 
+override_dh_gencontrol:
+	dh_gencontrol $(patsubst $(tmp)/skip-%,-N adequate-testpkg-%,$(wildcard $(tmp)/skip-*))
+
+override_dh_builddeb:
+	dh_builddeb $(patsubst $(tmp)/skip-%,-N adequate-testpkg-%,$(wildcard $(tmp)/skip-*))
+
 execute_after_dh_builddeb:
 	rm debian/adequate-testpkg-obsolete-conffile/etc/adequate/test-obsolete-conffile
 	sed -i -e '/test-obsolete/d' debian/adequate-testpkg-obsolete-conffile/DEBIAN/conffiles

## adequate 0.15.12

=== debian/changelog ===
adequate (0.15.12) unstable; urgency=medium

  * Set maintainer to team email address, and myself as uploader.
  * Actually bump Standards-Version to 4.7.0.

 -- Serafeim Zanikolas <sez@debian.org>  Sat, 18 May 2024 12:36:48 +0200

adequate (0.15.11) unstable; urgency=medium

  * Fix undefined-symbol false positive for libc6 (Closes: #1071093). Thanks
    to Aurelien Jarno <aurel32@debian.org> for the helpful context in BTS.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Serafeim Zanikolas <sez@debian.org>  Fri, 17 May 2024 21:32:34 +0200

adequate (0.15.10) unstable; urgency=medium

  * New maintainer (Closes: #786808).
  * Update Recommends to pkgconf (fixes depends-on-obsolete-package lint
    error).
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Serafeim Zanikolas <sez@debian.org>  Mon, 13 May 2024 20:41:05 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: adequate
 Section: utils
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
+Maintainer: Debian Adequate Maintainers <team+adequate-maint@tracker.debian.org>
+Uploaders: Serafeim Zanikolas <sez@debian.org>
 Build-Depends: debhelper-compat (= 13),
                perl,
                python3,
                python3-apt
-Standards-Version: 4.5.1
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/adequate.git
 Vcs-Browser: https://salsa.debian.org/debian/adequate
 Homepage: https://salsa.debian.org/debian/adequate
@@ -17,7 +18,7 @@
 Depends: debconf,
          ${misc:Depends},
          ${perl:Depends}
-Recommends: pkg-config
+Recommends: pkgconf
 Description: Debian package quality testing tool
  adequate checks packages installed on the system and reports bugs and policy
  violations.

## adequate 0.16.9

=== doc/Makefile ===
.PHONY: all
all: adequate.1

adequate.1: adequate.md
	mkdir -p ../_build/tmp/
	go-md2man -in=adequate.md -out=../_build/tmp/adequate.1

.PHONY: clean
clean:

# vim:ts=4 sts=4 sw=4 noet

=== debian/changelog ===
adequate (0.16.9) unstable; urgency=medium

  * Build-depend on golang-any rather than golang-go (Closes: #1077724).
    Thanks to John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
  * Propagate --verbose to debconf-talking subprocess.

 -- Serafeim Zanikolas <sez@debian.org>  Sat, 03 Aug 2024 23:45:37 +0200

adequate (0.16.8) unstable; urgency=medium

  * Fix parsing of update-binfmts output (Closes: #1077805).
  * Suppress false positive broken-symlink tags, for files that are either
    missing or cannot be stat'ed (Closes: #1077706).

 -- Serafeim Zanikolas <sez@debian.org>  Sat, 03 Aug 2024 23:19:51 +0200

adequate (0.16.7) unstable; urgency=medium

  * Suppress missing-alternative for wmaker (see #868334).
  * README: revise autopkgtest instructions (Closes: #743198). Thanks to
    "Martin-Éric Racine" <martin-eric.racine@iki.fi> for the suggestions.
  * Add version constraint to Build-Depends: golang-go, for relatively new
    stdlib packages (cmp and slices). Closes: #1077724.
  * Pending mode should propagate debconf setting, rather than set it
    unconditionally (Closes: #1077703).
  * Add crude progress reporting, behind --verbose (Closes: #1077705).

 -- Serafeim Zanikolas <sez@debian.org>  Tue, 30 Jul 2024 19:40:10 +0200

adequate (0.16.6) unstable; urgency=medium

  * Drop non-arch binary packages if at least one arch-equivalent is also
    specified (e.g. drop "foo" when accompanied by "foo:i386"; Closes:
    #1077590).
  * Fix gitlab CI config.
  * Minor refactoring changes.

 -- Serafeim Zanikolas <sez@debian.org>  Tue, 30 Jul 2024 14:43:17 +0200

adequate (0.16.5) unstable; urgency=medium

  * Emit obsolete-conffile tags for conffiles that are no longer shipped by a
    package only when they have not been locally modified (Closes: #981767).
  * Minor additions to CONTRIB.md
  * debian/rules: drop hardening settings. dh is supposed to take care of that
    automatically, according to wiki.d.o/Hardening
  * debian/copyright: add entry for license-incompatibility.md

 -- Serafeim Zanikolas <sez@debian.org>  Mon, 29 Jul 2024 00:11:06 +0200

adequate (0.16.4) unstable; urgency=medium

  * Ship README file to encourage package maintainers to run adequate using
    autopkgtest (Closes: #743198). Thanks to "Axel Beckert" <abe@debian.org>
    for providing the autopkgtest samples.
  * Ship CONTRIB.md

 -- Serafeim Zanikolas <sez@debian.org>  Fri, 26 Jul 2024 21:35:40 +0200

adequate (0.16.3) unstable; urgency=medium

  * Run external tools from the root directory, rather than from whatever
    happens to be the current working directory, in case the latter gets
    deleted (Closes: #856886).

 -- Serafeim Zanikolas <sez@debian.org>  Thu, 25 Jul 2024 00:26:20 +0200

adequate (0.16.2) unstable; urgency=medium

  * Disable PIE for mips64el to address FTBFS.
  * Minor cleanups in debian/{rules,control}

 -- Serafeim Zanikolas <sez@debian.org>  Wed, 24 Jul 2024 23:16:50 +0200

adequate (0.16.1) unstable; urgency=medium

  * Keep going when update-alternatives returns unexpected output (Closes:
    #857265).
  * Enable build hardening.

 -- Serafeim Zanikolas <sez@debian.org>  Tue, 23 Jul 2024 01:04:05 +0200

adequate (0.16) unstable; urgency=medium

  * Release complete rewrite of adequate. This is meant to be largely
    backwards-compatible, see relevant NEWS entry for details.
  * Add --fail flag to return non-zero exit status when at least one tag is
    emitted for at least one package (Closes: #742932).
  * Ship license-incompatibility.md in the hope that it'll attract more
    scrutiny.

 -- Serafeim Zanikolas <sez@debian.org>  Wed, 17 Jul 2024 21:49:06 +0200

adequate (0.15.15) experimental; urgency=low

  * Fix apt-hook and debconf integration (Closes: #1076157).

 -- Serafeim Zanikolas <sez@debian.org>  Sun, 07 Jul 2024 17:25:31 +0200

adequate (0.15.13) experimental; urgency=low

  * Upload to experimental a complete rewrite of adequate in another language.

 -- Serafeim Zanikolas <sez@debian.org>  Sat, 06 Jul 2024 16:32:11 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,11 @@
 Priority: optional
 Maintainer: Debian Adequate Maintainers <team+adequate-maint@tracker.debian.org>
 Uploaders: Serafeim Zanikolas <sez@debian.org>
-Build-Depends: debhelper-compat (= 13),
-               perl,
+Build-Depends: debhelper (>= 13.4),
+               debhelper-compat (= 13),
+               golang-any (>= 2:1.21),
+	       dh-golang,
+	       go-md2man,
                python3,
                python3-apt
 Standards-Version: 4.7.0
@@ -12,12 +15,14 @@
 Vcs-Browser: https://salsa.debian.org/debian/adequate
 Homepage: https://salsa.debian.org/debian/adequate
 Rules-Requires-Root: no
+XS-Go-Import-Path: salsa.debian.org/debian/adequate
 
 Package: adequate
-Architecture: all
+Architecture: any
 Depends: debconf,
+	 ${shlibs:Depends},
          ${misc:Depends},
-         ${perl:Depends}
+Built-Using: ${misc:Built-Using}
 Recommends: pkgconf
 Description: Debian package quality testing tool
  adequate checks packages installed on the system and reports bugs and policy

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1

%:
	dh $@ --builddirectory=_build --with=golang

override_dh_auto_clean:
	$(MAKE) -C doc/ clean
	$(MAKE) -C tests/ clean
	rm -rf _build adequate

override_dh_auto_test:
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	adt_adequate=_build/bin/adequate adt_testpkg=dpkg debian/tests/smoke-test
	$(MAKE) -C tests/ changes
endif

execute_before_dh_auto_build:
	sed -i -e 's/dummy-adequate-version/$(DEB_VERSION)/' \
		_build/src/salsa.debian.org/debian/adequate/adequate.go
execute_after_dh_auto_build:
	rm -rf _build/src _build/bin/private
	$(MAKE) -B -C doc/

## adequate 0.16.14

=== debian/changelog ===
adequate (0.16.14) unstable; urgency=medium

  * Limit reporting of policy violations via debconf to a maximum of 64k
    bytes. Messages somewhere in the (64k, 128k] range cause whiptail to fail
    with "Argument list too long" (Closes: #1077704).

 -- Serafeim Zanikolas <sez@debian.org>  Fri, 16 Aug 2024 01:26:18 +0200

adequate (0.16.13) unstable; urgency=medium

  * Do not mess-up the console (Closes: #1076788). Thanks to Antti Kultanen
    <debbugs@pyksy.fi> and gregor herrmann <gregoa@debian.org> for reporting
    the issue and helping me to reproduce it. Also thanks to Guillem Jover
    <guillem@debian.org> for tracking down the issue to adequate (it was
    initially reported against apt).
    * in respawning adequate via debconf, set only SysProcAttr.Setsid and let
      exec.Run() figure out the controlling terminal file descriptor (rather
      than asking it, via SysProcAttr.Setctty, to respect SysProcAttr.Ctty
      which we in fact were not setting (so it'd would only work for whatever
      setups the default (0) fd was valid)
    * do not close stdout; this was done in the perl version of adequate but
      with the rewrite in go, it seems to mess up apt hooks after adequate
  * Other cleanups:
    * eliminate deferred calls from main(); they don't get to run when calling
      os.Exit() (directly, or via log.Fatal())
    * respawn via debconf only when --debconf is set
    * set child stderr to parent stderr (rather than parent stdout)

 -- Serafeim Zanikolas <sez@debian.org>  Thu, 15 Aug 2024 23:38:38 +0200

## adequate 0.16.18

=== debian/changelog ===
adequate (0.16.18) unstable; urgency=medium

  * Do not pass to dpkg ambiguous package names, in multi-arch setups.  (e.g.
    drop "foo" when "foo:i386" and "foo:amd64" are also installed, otherwise
    dpkg doesn't know whether "foo" refers to the i386 or the amd64 package;
    Closes: #1077590). Thanks to Sebastian Ramacher <sramacher@debian.org> for
    reporting the issue and testing potential fixes.

 -- Serafeim Zanikolas <sez@debian.org>  Wed, 21 Aug 2024 00:00:28 +0200

## adequate 0.16.19

=== debian/changelog ===
adequate (0.16.19) unstable; urgency=medium

  * Drop incompatible-licenses tag and license-incompatibility.md;
    Closes: #982264. For rationale, see
    https://lists.debian.org/D4I3W5WV4FPA.370EB5JA9FHHJ@debian.org.

 -- Serafeim Zanikolas <sez@debian.org>  Sat, 05 Oct 2024 20:36:04 +0200

## adequate 0.16.20

=== debian/changelog ===
adequate (0.16.20) unstable; urgency=medium

  * Add new tags for invalid user/group values in systemd service unit
    and D-Bus configuration files, as well as in sysvinit scripts;
    Closes: #1003635, #1003636, #1003637.

 -- Serafeim Zanikolas <sez@debian.org>  Sun, 20 Oct 2024 21:24:59 +0200

## adequate 0.17

=== debian/changelog ===
adequate (0.17) unstable; urgency=medium

  * Ignore empty user/group values when validating sysvinit scripts.
  * Announce new and recently retired tags in NEWS.
  * Retroactively update minor version for the new tags introduced in the
    previous upload.

 -- Serafeim Zanikolas <sez@debian.org>  Tue, 22 Oct 2024 22:04:11 +0200

=== debian/control ===
--- 
+++ 
@@ -34,8 +34,8 @@
   * obsolete conffiles;
   * Python modules not byte-compiled;
   * missing libraries, undefined symbols, symbol size mismatches;
-  * license conflicts;
   * program name collisions;
   * missing alternatives;
   * missing binfmt interpreters and detectors;
-  * missing pkg-config dependencies.
+  * missing pkg-config dependencies;
+  * invalid user/group values in systemd/D-Bus/sysvinit files.

## adequate 0.17.1

=== debian/changelog ===
adequate (0.17.1) unstable; urgency=medium

  * d/control: add autodep8 testsuites for go and adequate (the latter is
    still to be implemented on the autodep8 end)
  * Misc clean-ups in debian/rules and autopkgtest tests

 -- Serafeim Zanikolas <sez@debian.org>  Fri, 08 Nov 2024 16:01:35 +0100

## adequate 0.17.2

=== debian/changelog ===
adequate (0.17.2) unstable; urgency=medium

  * Add examples/sbuild-hook for calling adequate from an sbuild chroot, for
    all sbuild-built binaries.
  * Update README for using adequate from sbuild and autopkgtest.

 -- Serafeim Zanikolas <sez@debian.org>  Sun, 24 Nov 2024 22:48:42 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
 Homepage: https://salsa.debian.org/debian/adequate
 Rules-Requires-Root: no
 XS-Go-Import-Path: salsa.debian.org/debian/adequate
+Testsuite: autopkgtest-pkg-go, autopkgtest-pkg-adequate
 
 Package: adequate
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -24,3 +24,6 @@
 execute_after_dh_auto_build:
 	rm -rf _build/src _build/bin/private
 	$(MAKE) -B -C doc/
+
+override_dh_fixperms:
+	dh_fixperms -Xexamples

## adequate 0.17.3

=== doc/Makefile ===
.PHONY: all
all: adequate.1

adequate.md: manpage.header manpage.footer tags.desc
	cd ../private && go run gen-markdown-manpage.go

# This should depend on adequate.md, but it doesn't to keep things simple.
# (That target depends on the adequate binary to get the list of tags, and
# that's not necessarily built before the manpage.)
adequate.1:
	mkdir -p ../_build/tmp/
	go-md2man -in=adequate.md -out=../_build/tmp/adequate.1

manpage-preview:
	man -l ../_build/tmp/adequate.1

.PHONY: clean
clean:

# vim:ts=4 sts=4 sw=4 noet

=== debian/changelog ===
adequate (0.17.3) unstable; urgency=medium

  * Replace use of syscall package with golang.org/x/sys/unix, as the former
    is officially "not portable".
  * Drop examples/sbuild-hook; it's broken.

 -- Serafeim Zanikolas <sez@debian.org>  Fri, 03 Jan 2025 21:12:06 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Build-Depends: debhelper (>= 13.4),
                debhelper-compat (= 13),
                golang-any (>= 2:1.21),
+	       golang-golang-x-sys-dev,
 	       dh-golang,
 	       go-md2man,
                python3,

=== debian/rules ===
--- 
+++ 
@@ -18,12 +18,12 @@
 	$(MAKE) -C tests/ changes
 endif
 
+execute_after_dh_auto_configure:
+	test -e _build/src/golang.org || ln -s /usr/share/gocode/src/golang.org _build/src/
+
 execute_before_dh_auto_build:
 	sed -i -e 's/dummy-adequate-version/$(DEB_VERSION)/' \
 		_build/src/salsa.debian.org/debian/adequate/adequate.go
 execute_after_dh_auto_build:
-	rm -rf _build/src _build/bin/private
+	rm -rf _build/src/salsa.debian.org _build/bin/private
 	$(MAKE) -B -C doc/
-
-override_dh_fixperms:
-	dh_fixperms -Xexamples
